      PROGRAM Backus_validation_frequency_angle

      include 'sizes'

      character zz*100
      integer nfrec,nmat,mat_type,nfwork
      real*8 fmin,fmax,fwork,lado,h,deltap
      complex*16 aim
      integer i,j,k,nx,ny
	 
! ---- Viscoelastic parameters

      integer nl(mnmat)
      real*8  rho(mnmat),dl(mnmat) 
      real*8 ks(mnmat),ros(mnmat),km(mnmat),mum(mnmat),phi(mnmat),
     . cappa(mnmat),rof(mnmat),kf(mnmat),eta(mnmat),struc(mnmat)	 
      real*8 angle,rad,freq,psi1,psi2,psi3
      real*8 Qpbk,Vpbk,Vpebk,Qsbk,Vsbk,Vsebk,Qshbk,Vshbk,Vshebk
      real*8 vp_eq,vpe_eq,vs_eq,vse_eq,vsh_eq,vshe_eq,qp_eq,qs_eq,qsh_eq
      Real*8 theta,s,c,co2,c2,s2,sc2,dens
	Real*8 Re_p11,Re_p33,Re_p13,Re_p55,Re_p66
      Real*8 Im_p11,Im_p33,Im_p13,Im_p55,Im_p66
	Real*8 Re_p11a,Re_p33a,Re_p13a,Re_p55a,Re_p66a
      Real*8 Im_p11a,Im_p33a,Im_p13a,Im_p55a,Im_p66a
	Real*8 Re_eps,Im_eps,Re_eps11,Im_eps11,Re_eps33,Im_eps33  
      Real*8 vpex_eq,vpez_eq,vsex_eq,vsez_eq,vshex_eq,vshez_eq
	Real*8 vpexbk,vpezbk,vsexbk,vsezbk,vshexbk,vshezbk	 
!	Complex*16 em,v1,v2,v2sh,p11,p33,p13,p55,p66,eps11,eps33
!      Complex*16 p11bk,p33bk,p55bk,p66bk,p13bk,sig
!      Complex*16 p11work,p33work,p55work,p66work,p13work
      Complex*16 p55,p66,p55bk,p66bk,p55work,p66work
      Complex*16 p11bkwork,p33bkwork,p13bkwork,p55bkwork,p66bkwork
      Complex*16 em,v1,v2,v2sh,p11,p33,p13,eps11,eps33
      Complex*16 p11bk,p33bk,p13bk,sig
      Complex*16 p11work,p33work,p13work
	complex*16 vv1,vv1h,bb1,bbb
	complex*16 denom,vv2,beta,xi,W,X,Z,p1,p2
	complex*16 D,al1,al2

! Anisotropic parameters

      complex*16 p11_l(mnmat),p33_l(mnmat),p13_l(mnmat),p55_l(mnmat)
     .          ,p66_l(mnmat)
	real*8 eps(mnmat),gam(mnmat),del(mnmat),alpha0(mnmat),beta0(mnmat)


   30 FORMAT (15F32.17)
   31 FORMAT ('Frequency(Hz)   VqP_eq(km/s)    VqP_backus(km/s)
     .    VqPe_eq(km/s)      VqPe_backus(km/s)    VqSV_eq(km/s)      
     .    VqSV_backus(km/s)   VqSVe_eq(km/s)    VqSVe_backus(km/s)
     .    VSH_eq(km/s)    VSH_backus(km/s)   VSHe_eq(km/s)    
     .    VSHe_backus(m/s)')     
   32 FORMAT ('Frequency(Hz)   InvQqP_eq    InvQqP_backus    InvQqSV_eq    
     .    InvQqSV_backus    InvQSH_eq    InvQSH_backus')  
   34 FORMAT ('Frequency(Hz)       Re_bulk_mod      Im_bulk_mod')

   41 FORMAT ('theta(deg)    psi1(deg)   V_qP_x(km/s)    V_qP_z(km/s)
     .    V_qP_x_bac(km/s)   V_qP_z_bac(km/s)    V_qPe_x(km/s)    
     .         V_qPe_z(km/s)    V_qPe_x_bac(km/s)    V_qPe_z_bac(km/s)')     
   42 FORMAT ('theta(deg)    psi2(deg)   V_qSV_x(km/s)    V_qSV_z(km/s)  
     .    V_qSV_x_bac(km/s)   V_qSV_z_bac(km/s)    V_qSVe_x(km/s)         
     .    V_qSVe_z(km/s)     V_qSVe_x_bac(km/s)    V_qSVe_z_bac(km/s)')          
   43 FORMAT ('theta(deg)    psi3(deg)    V_SH_x(km/s)    V_SH_z(km/s)  
     .    V_SH_x_bac(km/s)   V_SH_z_bac(km/s)    V_SHe_x(km/s)         
     .    V_SHe_z(km/s)     V_SHe_x_bac(km/s)    V_SHe_z_bac(km/s)')

   44 FORMAT ('theta(deg)    psi1(deg)   InvQ_qP_x    InvQ_qP_z     
     .    InvQ_qP_x_bac   InvQ_qP_z_bac')  
   45 FORMAT ('theta(deg)    psi2(deg)   psi3(deg)   InvQ_qSV_x    
     .    InvQ_qSV_z   InvQ_qSV_x_bac     InvQ_qSV_z_bac   InvQ_SH_x      
     .    InvQ_SH_z    InvQ_SH_x_bac    InvQ_SH_z_bac')                            
123    format(2g20.8)
! INPUT files

      open(unit=1,file='p11.freq',status='old')
      open(unit=2,file='p33.freq',status='old')
      open(unit=3,file='p55.freq',status='old')
      open(unit=4,file='p66.freq',status='old')
      open(unit=7,file='p13.freq',status='old')
c      open(unit=5,file='input.txt',status='unknown')


! OUTPUT files
	    
      open(unit=8,file='V_equiv.freq',status='unknown')
      open(unit=9,file='Inv_Q_equiv.freq',status='unknown')

      open(unit=12,file='V_qP',status='unknown')
      open(unit=13,file='V_qSV',status='unknown')
      open(unit=14,file='VSH',status='unknown')  
      open(unit=16,file='InvQ_P',status='unknown')
      open(unit=17,file='InvQ_S',status='unknown')
	      

      open(unit=20,file='vp_FE_eq.freq',status='unknown')
      open(unit=21,file='Vpbk.freq',status='unknown')
      open(unit=22,file='vs_FE_eq.freq',status='unknown')
      open(unit=23,file='Vsbk.freq',status='unknown')      
      open(unit=24,file='vsh_FE_eq.freq',status='unknown')
      open(unit=25,file='Vshbk.freq',status='unknown')   
      open(unit=26,file='qp_FE_eq_inv.freq',status='unknown')
      open(unit=27,file='qpbk_inv.freq',status='unknown')   
      open(unit=28,file='qs_FE_eq_inv.freq',status='unknown')
      open(unit=29,file='qsbk_inv.freq',status='unknown')
      open(unit=30,file='qsh_eq_FE_inv.freq',status='unknown')
      open(unit=31,file='qshbk_inv.freq',status='unknown')  

      open(unit=40,file='vp_FE_eq.angle',status='unknown')
      open(unit=41,file='Vpbk.angle',status='unknown')
      open(unit=42,file='vs_FE_eq.angle',status='unknown')
      open(unit=43,file='Vsbk.angle',status='unknown')      
      open(unit=44,file='vsh_FE_eq.angle',status='unknown')
      open(unit=45,file='Vshbk.angle',status='unknown')   
      open(unit=46,file='qp_FE_eq_inv.angle',status='unknown')
      open(unit=47,file='qpbk_inv.angle',status='unknown')   
      open(unit=48,file='qs_FE_eq_inv.angle',status='unknown')
      open(unit=49,file='qsbk_inv.angle',status='unknown')
      open(unit=50,file='qsh_FE_eq_inv.angle',status='unknown')
      open(unit=51,file='qshbk_inv.angle',status='unknown')  



      write(8,31)
      write(9,32)

      write(12,41)
      write(13,42)
      write(14,43)
      write(16,44)
      write(17,45)
      
      pi=4.d0*datan(1.d0)
       
      twopi = 2.d0*pi      
      aim=dcmplx(0.d0,1.d0)

!ccccccccccccccccccccccccccccccccccccccccccccccccccc

c      nfwork=21
       nfwork = 5
	angle=45.
c         angle = 30.   
      call readata(fmin,fmax,nfrec,nl,ros,phi,rof)

      rho(1)=(1.d0-phi(1))*ros(1)+phi(1)*rof(1)
      rho(2)=(1.d0-phi(2))*ros(2)+phi(2)*rof(2)

      dens=(rho(1)*nl(1)+rho(2)*nl(2))/(nl(1)+nl(2))

      print*,'dens=',dens
	print*,'angle (deg)=',angle
	print*,''
     
      read(1,*) 
      read(2,*) 
      read(3,*) 
      read(4,*) 
      read(7,*) 
    

! ***************************************************************
!       FREQUENCY LOOP
! Here we compute the moduli only at the working frequency fwork
! **************************************************************

      do ii=1,nfrec

! read p11,p33,p55,p66 and eps11,eps33

      read(1,*) freq,Re_p11,Re_p11a,Im_p11,Im_p11a
	read(2,*) freq,Re_p33,Re_p33a,Im_p33,Im_p33a
      read(3,*) freq,Re_p55,Re_p55a,Im_p55,Im_p55a
      read(4,*) freq,Re_p66,Re_p66a,Im_p66,Im_p66a
      read(7,*) freq,Re_p13,Re_p13a,Im_p13,Im_p13a


! Compute pij using numerical results

	p11=(Re_p11+aim*Im_p11) 
	p33=(Re_p33+aim*Im_p33) 
	p55=(Re_p55+aim*Im_p55) 
      p66=(Re_p66+aim*Im_p66)
      p13=(Re_p13+aim*Im_p13)


! --- Compute Analytical pij

	p11bk=(Re_p11a+aim*Im_p11a) 
	p33bk=(Re_p33a+aim*Im_p33a) 
	p55bk=(Re_p55a+aim*Im_p55a) 
      p66bk=(Re_p66a+aim*Im_p66a)
      p13bk=(Re_p13a+aim*Im_p13a)

! Save moduli at the working frequency for polar curves

	IF (ii.eq.nfwork) THEN

	   fwork=freq
	   p11work=p11
	   p33work=p33
	   p55work=p55
	   p66work=p66
         p13work=p13

	   p11bkwork=p11bk
	   p33bkwork=p33bk
	   p55bkwork=p55bk
	   p66bkwork=p66bk
         p13bkwork=p13bk

      print*,'working frequency (Hz)=',fwork
      print*,''
      print*,'numerical at working frequency'
      print*,''
	print*,'p11=',p11
      print*,'p33=',p33
	print*,'p13=',p13
	print*,'p55=',p55
      print*,'p66=',p66
      print*,''

c	read(*,'(a)') zz

	ENDIF

! ----------------- Compute Quality factors and Velocities using numerical results -------------

      CALL VQanis(angle,dens,p11,p33,p55,p66,p13,psi1,psi2,psi3,
     .    vp_eq,vpex_eq,vpez_eq,vs_eq,vsex_eq,vsez_eq,vsh_eq,vshex_eq,
     .    vshez_eq,qp_eq,qs_eq,qsh_eq)

      vpe_eq=sqrt(vpex_eq**2+vpez_eq**2)      ! qP-wave energy velocity
      vse_eq=sqrt(vsex_eq**2+vsez_eq**2)      !  qSV-wave energy velocity
      vshe_eq=sqrt(vshex_eq**2+vshez_eq**2)   !  SH-wave energy velocity	 

!	print*,'ii,p66,p66bk=',ii,p66,p66bk

! ----------------- Compute Quality factors and Velocities using Backus results -------------

      CALL VQanis(angle,dens,p11bk,p33bk,p55bk,p66bk,p13bk,psi1,psi2,
     .    psi3,vpbk,vpexbk,vpezbk,vsbk,vsexbk,vsezbk,vshbk,vshexbk,
     .    vshezbk,qpbk,qsbk,qshbk)

      vpebk=sqrt(vpexbk**2+vpezbk**2)      ! qP-wave energy velocity
      vsebk=sqrt(vsexbk**2+vsezbk**2)      !  qSV-wave energy velocity
      vshebk=sqrt(vshexbk**2+vshezbk**2)   !  SH-wave energy velocity	 

! ----- Write results on files
	 
      write(8,30)freq,vp_eq,Vpbk,vpe_eq,Vpebk
     .               ,vs_eq,Vsbk,vse_eq,Vsebk
     .	           ,vsh_eq,Vshbk,vshe_eq,Vshebk
      write(9,30)freq,1./qp_eq,1./Qpbk,1./qs_eq,1./Qsbk,
     .                1./qsh_eq,1./Qshbk  

      write(20,123)freq,vp_eq
      write(21,123)freq,Vpbk
      write(22,123)freq,vs_eq
      write(23,123)freq,Vsbk
      write(24,123)freq,vsh_eq
      write(25,123)freq,Vshbk
      write(26,123)freq,1000.d0/qp_eq
      write(27,123)freq,1000.d0/Qpbk
      write(28,123)freq,1000.d0/qs_eq
      write(29,123)freq,1000.d0/Qsbk
      write(30,123)freq,1000.d0/qsh_eq
      write(31,123)freq,1000.d0/Qshbk
              

      enddo

! --- local properties at working frequency

	p11bk=p11bkwork
	p33bk=p33bkwork
	p55bk=p55bkwork
	p66bk=p66bkwork
      p13bk=p13bkwork

      print*,'analytical at working frequency'
      print*,''
	print*,'p11bk=',p11bk
      print*,'p33bk=',p33bk
	print*,'p13bk=',p13bk
	print*,'p55bk=',p55bk
      print*,'p66bk=',p66bk

c	read(*,'(a)') zz
        
! ***************************************************************
!       ANGLE LOOP
! ***************************************************************

      do theta=0.,90.,3.

	angle=theta

	If (angle.eq.0.) THEN 
	   angle=0.1
	ENDIF
      If (angle.eq.90.) THEN 
	   angle=89.9
	ENDIF

	print*,'angle (deg)=',angle

!      compute polar curves using numerical moduli

      CALL VQanis(angle,dens,p11work,p33work,p55work,p66work,
     .    p13work,psi1,psi2,psi3,vp_eq,vpex_eq,vpez_eq,vs_eq,vsex_eq,
     .    vsez_eq,vsh_eq,vshex_eq,vshez_eq,qp_eq,qs_eq,qsh_eq)

      rad=angle*pi/180

      vpx_eq=vp_eq*sin(rad)
      vpz_eq=vp_eq*cos(rad)
      vsx_eq=vs_eq*sin(rad)
      vsz_eq=vs_eq*cos(rad)
      vshx_eq=vsh_eq*sin(rad)
      vshz_eq=vsh_eq*cos(rad)

! --- Plot Q's in function of the energy angles

!      qpx_eq=1.d3/qp_eq*sin(psi1)
!      qpz_eq=1.d3/qp_eq*cos(psi1)
!      qsx_eq=1.d3/qs_eq*sin(psi2)
!      qsz_eq=1.d3/qs_eq*cos(psi2)
!      qshx_eq=1.d3/qsh_eq*sin(psi3)
!      qshz_eq=1.d3/qsh_eq*cos(psi3)

! --- Plot Q's in function of the phase angles

      qpx_eq=1.d3/qp_eq*sin(rad)
      qpz_eq=1.d3/qp_eq*cos(rad)
      qsx_eq=1.d3/qs_eq*sin(rad)
      qsz_eq=1.d3/qs_eq*cos(rad)
      qshx_eq=1.d3/qsh_eq*sin(rad)
      qshz_eq=1.d3/qsh_eq*cos(rad)

      write(40,123)angle,vp_eq
      write(41,123)angle,Vpbk
      write(42,123)angle,vs_eq
      write(43,123)angle,Vsbk
      write(44,123)angle,vsh_eq
      write(45,123)angle,Vshbk
      write(46,123)angle,1.d3/qp_eq
      write(47,123)angle,1.d3/Qpbk
      write(48,123)angle,1.d3/qs_eq
      write(49,123)angle,1.d3/Qsbk
      write(50,123)angle,1.d3/qsh_eq
      write(51,123)angle,1.d3/Qshbk

!      compute polar curves using Backus moduli  

      CALL VQanis(angle,dens,p11bk,p33bk,p55bk,p66bk,p13bk,psi1,psi2,
     .    psi3,vpbk,vpexbk,vpezbk,vsbk,vsexbk,vsezbk,vshbk,vshexbk,
     .    vshezbk,qpbk,qsbk,qshbk)

      vpxbk=vpbk*sin(rad)
      vpzbk=vpbk*cos(rad)
      vsxbk=vsbk*sin(rad)
      vszbk=vsbk*cos(rad)
      vshxbk=vshbk*sin(rad)
      vshzbk=vshbk*cos(rad)

! --- Plot Q's in function of the energy angles

!      qpxbk=1.d3/qpbk*sin(psi1)
!      qpzbk=1.d3/qpbk*cos(psi1)
!      qsxbk=1.d3/qsbk*sin(psi2)
!      qszbk=1.d3/qsbk*cos(psi2)
!      qshxbk=1.d3/qshbk*sin(psi3)
!      qshzbk=1.d3/qshbk*cos(psi3)

! --- Plot Q's in function of the phase angles

      qpxbk=1.d3/qpbk*sin(rad)
      qpzbk=1.d3/qpbk*cos(rad)
      qsxbk=1.d3/qsbk*sin(rad)
      qszbk=1.d3/qsbk*cos(rad)
      qshxbk=1.d3/qshbk*sin(rad)
      qshzbk=1.d3/qshbk*cos(rad)

! ----- Write polar curves on files
	 
      write(12,30)angle,psi1*180/pi,vpx_eq,vpz_eq,vpxbk,vpzbk,
     .                vpex_eq,vpez_eq,vpexbk,vpezbk
      write(13,30)angle,psi2*180/pi,vsx_eq,vsz_eq,vsxbk,vszbk,
     . vsex_eq,vsez_eq,vsexbk,vsezbk
      write(14,30)angle,psi3*180/pi,vshx_eq,vshz_eq,vshxbk,vshzbk,
     . vshex_eq,vshez_eq,vshexbk,vshezbk
      write(16,30)angle,psi1*180/pi,qpx_eq,qpz_eq,qpxbk,qpzbk
      write(17,30)angle,psi2*180/pi,psi3*180/pi,qsx_eq,qsz_eq,qsxbk,
     .                qszbk,qshx_eq,qshz_eq,qshxbk,qshzbk

	enddo

	stop
	end

! *********************************************************************


      SUBROUTINE VQanis(angle,dens,p11,p33,p55,p66,p13,psi1,psi2,psi3,
     .            vp,vpex,vpez,vs,vsex,vsez,vsh,vshex,vshez,qp,qs,qsh) 

      include 'sizes'

      real*8 aqq1,c1,c1e,aqq2,cc2,c2e,aqq2sh,c2sh,c2esh
      real*8 qf1x,qf1z                       
      real*8 qf2x,qf2z
	real*8 dens,angle                   
      real*8 c1x,c1z                 
      real*8 c2x,c2z                 
      real*8 c1ex,c1ez,theta,psi1,psi2,psi3            
      real*8 c2ex,c2ez
	real*8 vp,vpex,vpez,vs,vsex,vsez,vsh,vshex,vshez,qp,qs,qsh       
	complex*16 p11,p33,p13,p55,p66
!      real*8 p55,p66
!      complex*16 p11,p33,p13
	complex*16 em,v1,vv1,vv1h,bb1,bbb,v2,v2sh
	complex*16 denom,vv2,beta,xi,W,X,Z,p1,p2
	complex*16 D,al1,al2
	complex*16 s1,s3

!c theta measured from vertical axis

      pi=4.d0*datan(1.d0)
       
      twopi = 2.d0*pi      
      aim=dcmplx(0.d0,1.d0)

      theta=angle*pi/180
!*                                                                               
       s=sin(theta)                                                            
       c=cos(theta)  
       co2=cos(2.*theta)
       c2=c*c                                                                   
       s2=s*s                                                                   
       sc2=s2*c2                                                                
!*                                                                               
!*      Phase velocity and quality factor                                                          
!*      ----------------------------------                                                           
!*                                                                               
       em=((p11-p55)*s*s+(p55-p33)*c*c)**2+4.*(p13+p55)*                
     .     (p13+p55)*s*s*c*c                                                  
       em=sqrt(em)                                                            
       v1=sqrt(p55+p11*s*s+p33*c*c+em)/sqrt(2.*dens)                      
       v2=sqrt(p55+p11*s*s+p33*c*c-em)/sqrt(2.*dens)
	 v2sh=sqrt(p66*s*s+p55*c*c)/sqrt(dens)   	                       
       vp=1./dreal(1/v1)   
       qp=dreal(v1*v1)/dimag(v1*v1)	
       vs=1./dreal(1/v2)   
       qs=dreal(v2*v2)/dimag(v2*v2)	  	     
       vsh=1./dreal(1./v2sh)  
	 qsh=dreal(v2sh*v2sh)/dimag(v2sh*v2sh)         

!*                                                                               
!*      Energy velocity                                                          
!*      ---------------                                                          

!c ! qP-wave energy velocity

       bbb=p11*s**2-p33*c**2+p55*co2
	 beta=SQRT(em+bbb)
	 xi=SQRT(em-bbb)

       W=p55*(xi*s+beta*c)
       X=beta*p11*s+xi*p13*c
       Z=beta*p13*s+xi*p33*c

       p1=conjg(beta)*X+conjg(xi)*W
       p2=conjg(beta)*W+conjg(xi)*Z
       tp=dreal(p1)/dreal(p2)
       psi1=atan(tp)

       vpex=vp/(s+c/tp)
       vpez=vp/(s*tp+c) 

! Formulation for inhomogeneous waves

!      s1=s/v1
!	s3=c/v1

!	beta=SQRT((p55*s1**2+p33*s3**2-dens)/
!     .          (p11*s1**2+p33*s3**2+p55*(s1**2+s3**2)-2*dens))
!	xi=SQRT((p11*s1**2+p55*s3**2-dens)/
!     .          (p11*s1**2+p33*s3**2+p55*(s1**2+s3**2)-2*dens))
!	 W=p55*(xi*s1+beta*s3)
!       X=beta*p11*s1+xi*p13*s3
!       Z=beta*p13*s1+xi*p33*s3

!       vpex=1./Real(s1+s3/tp)
!       vpez=1./Real(s1*tp+s3)
      
!	 print *,'c1,c1e=',c1,c1e


!c qSV-wave energy velocity

       bbb=p11*s**2-p33*c**2+p55*co2
	 beta=SQRT(em-bbb)
	 xi=-SQRT(em+bbb)  

       W=p55*(xi*s+beta*c)
       X=beta*p11*s+xi*p13*c
       Z=beta*p13*s+xi*p33*c

       p1=conjg(beta)*X+conjg(xi)*W
       p2=conjg(beta)*W+conjg(xi)*Z
       tp=dreal(p1)/dreal(p2)
       psi2=atan(tp)

       vsex=vs/(s+c/tp)
       vsez=vs/(s*tp+c) 

! Formulation for inhomogeneous waves

!      s1=s/v2
!	s3=c/v2

!	beta=SQRT((p55*s1**2+p33*s3**2-dens)/
!     .          (p11*s1**2+p33*s3**2+p55*(s1**2+s3**2)-2*dens))
!	xi=-SQRT((p11*s1**2+p55*s3**2-dens)/
!     .          (p11*s1**2+p33*s3**2+p55*(s1**2+s3**2)-2*dens))
!	 W=p55*(xi*s1+beta*s3)
!       X=beta*p11*s1+xi*p13*s3
!       Z=beta*p13*s1+xi*p33*s3

!       vsex=1./Real(s1+s3/tp)
!       vsez=1./Real(s1*tp+s3) 

!	 print*,'cc2,c2e=',cc2,c2e


! Formulation from Carcione (1992)

!       vv1=p11*s2+p55*c2-dens*v2*v2                                            
!       vv1h=-vv1/(p13+p55)                                                    
!       bb1=vv1h/c/s                                                             
!       abb1=abs(bb1)**2                                                       
!       de11=dens*(1.+abb1)*real(v2)  
!	 print *,'vv1,vv1h,bb1=',vv1,vv1h,bb1                                          
!       c2ex=vs_eq*real((p11*s+p13*bb1*c+p55*(conjg(bb1)                 
!     .          *c+abb1*s))/v2)/de11                                           
!       c2ez=vs_eq*real((p33*c*abb1+p13*conjg(bb1)*s+p55*(c+             
!     .          bb1*s))/v2)/de11
!       vse=sqrt(c2ex**2+c2ez**2)   !  energy velocity
!	 print*,'cc2,c2e=',cc2,c2e

! SH-wave energy velocity

       psi3=atan(dReal(p66/v2sh)*tan(theta)/dReal(p55/v2sh))
       vshex=(vsh/(dens*dreal(v2sh)))*s*dreal(p66/v2sh)                                       
       vshez=(vsh/(dens*dreal(v2sh)))*c*dreal(p55/v2sh)

      return 

	end 

!************************************************************************

      subroutine readata(fmin,fmax,nfrec,nl,ros,phi,rof)

      include 'sizes'
      real*8 ks(mnmat),ros(mnmat),km(mnmat),mum(mnmat),phi(mnmat),
     1 cappa(mnmat),rof(mnmat),kf(mnmat),eta(mnmat),struc(mnmat),
     1  q_k(mnmat),q_s(mnmat),cte_k(mnmat),cte_s(mnmat),
     1  tau1(mnmat),tau2(mnmat)
      integer nfrec,nx,nmat,nl(mnmat)
      real*8 pi,twopi,h,fmin,fmax,lado
*  fracture stuff
      complex*16 alpha(mnfrac),beta(mnfrac)
      real*8 capa_N,eta_N,capa_T,eta_T,xL,freq_ref
      integer n_cells_per_block
*  ends fracture stuff

       pi = 4.d0*datan(1.d0)
       twopi = 2.d0*pi

      read(5,*)fmin
      read(5,*)fmax
      read(5,*)nfrec
      read(5,*)lado
      read(5,*)nx
      read(5,*)ny

      read(5,*)nmat


!* reads material properties for each material type
      
      do i=1,nmat
      read(5,*)nl(i)
      read(5,*)ks(i)
      read(5,*)ros(i)
      read(5,*)km(i)
      read(5,*)mum(i)
      read(5,*)phi(i)
      read(5,*)cappa(i)
      read(5,*)struc(i)
      read(5,*)rof(i)
      read(5,*)kf(i)
      read(5,*)eta(i)
      read(5,*)q_k(i)
      read(5,*)q_s(i)
      read(5,*)tau1(i)
      read(5,*)tau2(i)
c       write(6,*)' i, tau2(i) ',i,tau2(i)
  
          if(q_k(i).lt.1.d-10) then
            cte_k(i) = 0.d0 
           else
            cte_k(i) =2.d0/(pi*q_k(i))
           endif 
	  
          if(q_s(i).lt.1.d-10) then
            cte_s(i) = 0.d0
           else
            cte_s(i) =2.d0/(pi*q_s(i))
           endif      
      enddo
              

*reads fracture   data
c      read(5,*)capa_N
c      read(5,*)eta_N
  
c      read(5,*)capa_T
c      read(5,*)eta_T
      read(5,*)xL
       
      read(5,*)n_cells_per_block
      read(5,*)freq_ref
      read(5,*)key_fractal
      read(5,*)key_ZN_ZT
      read(5,*)capa_N
      read(5,*)eta_N
  
      read(5,*)capa_T
      read(5,*)eta_T

      h=lado/ny
      xL=n_cells_per_block*h    !  use n_cells_per_block o compute fracture spacing xL

      capa_N = capa_N/xL
      eta_N  = eta_N/(twopi*freq_ref*xL)

      capa_T= capa_T/xL
      eta_T = eta_T/(twopi*freq_ref*xL)


      n_frac = ny/n_cells_per_block-1
          
               
      return
      end
!**********************************************************************************************************