SUBROUTINE Output

USE Variables

USE DFT

IMPLICIT NONE

!------------------ Guardo el espectro de amplitud del desplazamiento ----------------------------

!!! OPEN ( UNIT=25 , FILE='ufreq-real-img.out' , STATUS='unknown' )
OPEN ( UNIT=26 , FILE='ufreq-abs-phase.out' , STATUS='unknown' )

DO i=1,npf

  !!! WRITE(25,*) (REAL(i,dp)-0.5d0) * df , REAL(ufreq(i)) , AIMAG(ufreq(i))
  WRITE(26,*) (REAL(i,dp)-0.5d0) * df , ABS(ufreq(i)) , ATAN( AIMAG(ufreq(i)) / REAL(ufreq(i)) )

END DO

!!! CLOSE( 25 )
CLOSE( 26 )

!------------------- Guardo el desplazamiento en tiempo (traza) ------------------------------------

OPEN ( UNIT=20 , FILE='traza.out' , STATUS='unknown' )

CALL IDFT ( ufreq , npf , desplz , npt , dt , dw )

DO i=1,npt

  WRITE(20,*) (REAL(i,dp)-1.d0)*dt , desplz(i) !!!, uanlt(i)

END DO

CLOSE ( 20 )

!----------------------------- Snapshots ---------------------------------------------------------

!DO jt=1,nsnap
  
 !DO j=0,NumEl-1
  
   !WRITE(100+jt,*) (REAL(j,dp)+1.d0/3.d0)*hval , u_foto(j,jt) * (dw/pi)

  !END DO

!END DO
!--------------------------------------------------------------------------------------------------

END SUBROUTINE Output