SUBROUTINE Snapshots(jf)      

USE Variables

IMPLICIT NONE

INTEGER, INTENT(in) :: jf

IF (jf==1) THEN

  ALLOCATE ( u_foto(0:NumEl-1,nsnap),tsnap(nsnap) )

  u_foto=0.d0

  DO j=1,nsnap

    tsnap(j)=(j-1)*(stime/nsnap) ! Arreglo que contienne el tiempo en segundos de cada snap

  END DO
  
END IF
    
DO j=0,NumEl-1

  DO   jt = 1,nsnap

    v = w(jf) * tsnap(jt) ! Argumento de la exponencial de la IDFT

    ! Arreglo que guarda los desplazamientos para cada elemento y cada tiempo de snap:

    u_foto(j,jt) = u_foto(j,jt) + REAL( (alpha(1,j)-alpha(2,j)/3.d0+alpha(3,j)/9.d0)*CMPLX (COS(v),SIN(v),dp) , dp )
    
  
  END DO

END DO

IF (jf==npf) THEN

DO jt=1,nsnap
  
  DO j=0,NumEl-1
  
    WRITE(100+jt,*) (REAL(j,dp)+1.d0/3.d0)*hval , u_foto(j,jt) * (dw/pi)

  END DO

END DO

END IF
      
END SUBROUTINE Snapshots
